#ifndef SBK_KTOOLBARPOPUPACTIONWRAPPER_H
#define SBK_KTOOLBARPOPUPACTIONWRAPPER_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <ktoolbarpopupaction.h>

#include <sbkpython.h>

#include <array>
namespace Shiboken { struct AutoDecRef; class GilState; }

namespace PySide { class DynamicQMetaObject; }

class KToolBarPopupActionWrapper : public KToolBarPopupAction
{
public:
    KToolBarPopupActionWrapper(const ::QIcon & icon, const ::QString & text, ::QObject * parent);
    KToolBarPopupActionWrapper(const KToolBarPopupActionWrapper &) = delete;
    KToolBarPopupActionWrapper& operator=(const KToolBarPopupActionWrapper &) = delete;
    KToolBarPopupActionWrapper(KToolBarPopupActionWrapper &&) = delete;
    KToolBarPopupActionWrapper& operator=(KToolBarPopupActionWrapper &&) = delete;
    ~KToolBarPopupActionWrapper() override;

    void childEvent(::QChildEvent * event) override;
    void connectNotify(const ::QMetaMethod & signal) override;
    ::QWidget * createWidget(::QWidget * parent) override;
    void customEvent(::QEvent * event) override;
    void deleteWidget(::QWidget * widget) override;
    void disconnectNotify(const ::QMetaMethod & signal) override;
    bool event(::QEvent * arg__1) override;
    bool eventFilter(::QObject * arg__1, ::QEvent * arg__2) override;
    void timerEvent(::QTimerEvent * event) override;

    const ::QMetaObject * metaObject() const override;
    int qt_metacall(QMetaObject::Call call, int id, void **args) override;
    void *qt_metacast(const char *_clname) override;
    static void pysideInitQtMetaTypes();

    void resetPyMethodCache();

private:
    mutable std::array<PyObject *, 9> m_PyMethodCache = {nullptr, nullptr, nullptr, nullptr, nullptr, nullptr, nullptr, nullptr, nullptr};
};

#endif // SBK_KTOOLBARPOPUPACTIONWRAPPER_H
